package gihyo.web.struts.action;

import java.util.Collection;
import java.util.Iterator;

import gihyo.interfaces.AuthRoleLocal;
import gihyo.interfaces.AuthRoleLocalHome;
import gihyo.interfaces.AuthRoleUtil;
import gihyo.interfaces.AuthUserLocal;
import gihyo.interfaces.AuthUserLocalHome;
import gihyo.interfaces.AuthUserUtil;
import gihyo.interfaces.AuthUserValue;

import javax.ejb.FinderException;
import javax.naming.NamingException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @web.ejb-local-ref
 *    name="ejb/AuthUser"
 *    type="Entity"
 *    home="gihyo.interfaces.AuthUserLocalHome"
 *    local="gihyo.interfaces.AuthUserLocal"
 *    link="AuthUser"
 * 
 * @web.ejb-local-ref
 *    name="ejb/AuthRole"
 *    type="Entity"
 *    home="gihyo.interfaces.AuthRoleLocalHome"
 *    local="gihyo.interfaces.AuthRoleLocal"
 *    link="AuthRole"
 */
public abstract class AbstractAction extends Action {

    public static final String LOGIN_USER = "LOGIN_USER";

    /**
     * execute\bh̑ɂɎs܂B
     */
    protected abstract ActionForward executeImpl(
        ActionMapping mapping,
        ActionForm form,
        HttpServletRequest request,
        HttpServletResponse response)
        throws Exception;

    /**
     * ZbVɃOC[UValueObjecto^܂B
    */
    public ActionForward execute(
        ActionMapping mapping,
        ActionForm form,
        HttpServletRequest request,
        HttpServletResponse response)
        throws Exception {

        AuthUserValue userValue = (AuthUserValue) request.getSession().getAttribute(LOGIN_USER);
        if (userValue == null) {
            userValue = getAuthUserValue(request.getRemoteUser());
            request.getSession().setAttribute(LOGIN_USER, userValue);
        }
        return executeImpl(mapping, form, request, response);
    }

    /**
     * w肳ꂽAJEgAuthUserLocal擾܂B
    */
    protected AuthUserLocal getAuthUserLocal(String account)
        throws FinderException, NamingException {

        Collection collection = AuthUserUtil.getLocalHome().findByAccount(account);
        Iterator iterator = collection.iterator();
        if(iterator.hasNext()){
            return (AuthUserLocal) iterator.next();
        }
        return null;
    }

    /**
     * w肳ꂽAJEgAuthUserValue擾܂B
    */
    protected AuthUserValue getAuthUserValue(String account)
        throws FinderException, NamingException {

        AuthUserLocal userLocal = getAuthUserLocal(account);
        if(userLocal != null){
            AuthUserValue userValue = userLocal.getValueObject();
            userValue.setAuthRole(userLocal.getAuthRole().getValueObject());
            return userValue;
        }
        return null;
    }
    
    /**
     * w肳ꂽPKAuthRoleLocal擾܂B
    */
    protected AuthRoleLocal getAuthRoleLocal(Integer pk)
        throws FinderException, NamingException {

        return AuthRoleUtil.getLocalHome().findByPrimaryKey(pk);
    }
    
    /**
     * ׂẴOC[U擾܂B
    */ 
    protected Collection getAllUsers()
        throws FinderException, NamingException {
        
        AuthUserLocalHome home = AuthUserUtil.getLocalHome();
        return home.findAll();
    }
    
    /**
     * ׂẴ[擾܂B
    */
    protected Collection getAllRoles()
        throws FinderException, NamingException {
        
        AuthRoleLocalHome home = AuthRoleUtil.getLocalHome();
        return home.findAll();
    }
    

}
