package gihyo.web.struts.action;

import gihyo.interfaces.AuthRoleLocal;
import gihyo.interfaces.AuthUserUtil;
import gihyo.web.struts.util.AlreadyExistException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @struts.action
 *    path="/addUser"
 *    scope="request"
 *    name="authUserForm"
 *    input="/viewAddUser.do"
 *    validate="true"
 *    roles="admin"
 *
 * @struts.action-forward
 *    name="success"
 *    path="/viewAllUsers.do"
 *    redirect="false"
 * 
 * @struts.action-exception
 *    key="errors.userexist"
 *    type="gihyo.web.struts.util.AlreadyExistException"
 */
public class AddUserAction extends AbstractAction {
    
    public ActionForward executeImpl(
      ActionMapping mapping,
      ActionForm form,
      HttpServletRequest request,
      HttpServletResponse response)
      throws Exception 
    {
        if (isCancelled(request) || (isTokenValid(request, true))) {
            return mapping.findForward("success");
        }
        String account  = BeanUtils.getProperty(form, "account");
        String password = BeanUtils.getProperty(form, "password");
        String userName = BeanUtils.getProperty(form, "userName");
        
        if(getAuthUserLocal(account)!=null){
            throw new AlreadyExistException();
        }
        Integer roleIdFk = (Integer)PropertyUtils.getProperty(form, "roleIdFk");
        AuthRoleLocal authRole = getAuthRoleLocal(roleIdFk);
        AuthUserUtil.getLocalHome().create(userName,account,password,authRole);
        
        return mapping.findForward("success");
    }
}