package gihyo.web.struts.action;

import gihyo.interfaces.AuthUserValue;
import gihyo.web.struts.util.AuthenticationException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * OC[U[̃pX[hύX܂B
 * 
 * @struts.action
 *    path="/changePassword"
 *    scope="request"
 *    name="passwordForm"
 *    input="/WEB-INF/changePassword.jsp"
 *    validate="true"
 *
 * @struts.action-forward
 *    name="success"
 *    path="/"
 *    redirect="false"
 * 
 * @struts.action-exception
 *    key="errors.authentication"
 *    type="gihyo.web.struts.util.AuthenticationException"
 */
public class ChangePasswordAction extends AbstractAction {

    public ActionForward executeImpl(
        ActionMapping mapping,
        ActionForm form,
        HttpServletRequest request,
        HttpServletResponse response)
        throws Exception {

        if (isCancelled(request) || (isTokenValid(request, true))) {
            return mapping.findForward("success");
        }
        String oldPassword = BeanUtils.getProperty(form, "oldPassword");
        String newPassword = BeanUtils.getProperty(form, "newPassword");

        AuthUserValue user = (AuthUserValue) request.getSession().getAttribute(LOGIN_USER);

        if (!oldPassword.equals(user.getPassword())) {
            throw new AuthenticationException();
        }
        user.setPassword(newPassword);
        getAuthUserLocal(request.getRemoteUser()).setPassword(newPassword);
        return mapping.findForward("success");
    }
}
