package gihyo.web.struts.action;

import gihyo.interfaces.AuthUserLocal;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @struts.action
 *    path="/editUser"
 *    scope="request"
 *    name="authUserForm"
 *    input="/viewAddUser.do"
 *    validate="true"
 *    roles="admin,manager"
 *
 * @struts.action-forward
 *    name="success"
 *    path="/viewAllUsers.do"
 *    redirect="false"
 */
public class EditUserAction extends AbstractAction {
    
    public ActionForward executeImpl(
      ActionMapping mapping,
      ActionForm form,
      HttpServletRequest request,
      HttpServletResponse response)
      throws Exception 
    {
        if (isCancelled(request) || (isTokenValid(request, true))) {
            return mapping.findForward("success");
        }
        String  account  = BeanUtils.getProperty(form, "account");
        String  userName = BeanUtils.getProperty(form, "userName");
        Integer roleIdFk = (Integer) PropertyUtils.getProperty(form, "roleIdFk");
        AuthUserLocal userLocal = getAuthUserLocal(account);
        userLocal.setUserName(userName);
        userLocal.setAuthRole(getAuthRoleLocal(roleIdFk));
        
        return mapping.findForward("success");
    }
}