package gihyo.web.struts.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @struts.action
 *    path="/removeUser"
 *    scope="request"
 *    name="selectEditForm"
 *    input="/viewAddUser.do"
 *    validate="false"
 *    roles="admin"
 *
 * @struts.action-forward
 *    name="success"
 *    path="/viewAllUsers.do"
 *    redirect="false"
 */
public class RemoveUserAction extends AbstractAction {
    
    public ActionForward executeImpl(
      ActionMapping mapping,
      ActionForm form,
      HttpServletRequest request,
      HttpServletResponse response)
      throws Exception 
    {
        if (isCancelled(request) || (isTokenValid(request, true))) {
            return mapping.findForward("success");
        }
        String account  = BeanUtils.getProperty(form, "account");
        getAuthUserLocal(account).remove();

        return mapping.findForward("success");
    }
}