package gihyo.web.struts.action;

import gihyo.web.struts.util.NotSelectedException;
import gihyo.web.struts.util.CantRemoveException;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.LookupDispatchAction;

/**
 * [U[̒ǉAXVA폜U܂B
 * 
 * @struts.action
 *    path="/selectEdit"
 *    name="selectEditForm"
 *    input="/viewAllUsers.do"
 *    scope="request"
 *    parameter="action"
 *    validate="false"
 *    roles="admin,manager"
 *
 * @struts.action-forward
 *    name="add"
 *    path="/viewAddUser.do"
 *    redirect="false"
 * 
 * @struts.action-forward
 *    name="edit"
 *    path="/viewEditUser.do"
 *    redirect="false"
 * 
 * @struts.action-forward
 *    name="remove"
 *    path="/viewRemoveUser.do"
 *    redirect="false"
 * 
 * @struts.action-exception
 *    key="errors.notselect"
 *    type="gihyo.web.struts.util.NotSelectedException"
 * 
 * @struts.action-exception
 *    key="errors.cantremove"
 *    type="gihyo.web.struts.util.CantRemoveException"
 */
public class SelectEditAction extends LookupDispatchAction {

    private static Map map;

    public ActionForward add(
        ActionMapping mapping,
        ActionForm form,
        HttpServletRequest request,
        HttpServletResponse response)
        throws Exception {

        return mapping.findForward("add");
    }

    public ActionForward edit(
        ActionMapping mapping,
        ActionForm form,
        HttpServletRequest request,
        HttpServletResponse response)
        throws Exception {

        String account = BeanUtils.getProperty(form, "account");
        if (account == null || account.length() == 0) {
            throw new NotSelectedException();
        }
        return mapping.findForward("edit");
    }

    public ActionForward remove(
        ActionMapping mapping,
        ActionForm form,
        HttpServletRequest request,
        HttpServletResponse response)
        throws Exception {
        String account = BeanUtils.getProperty(form, "account");
        if (account == null || account.length() == 0) {
            throw new NotSelectedException();
        }
        if(account.equals(request.getRemoteUser())){
            throw new CantRemoveException();
        }
        return mapping.findForward("remove");
    }

    protected Map getKeyMethodMap() {
        if (map == null) {
            map = new HashMap();
            map.put("sumit.add", "add");
            map.put("sumit.edit", "edit");
            map.put("sumit.remove", "remove");
        }
        return map;
    }
}