package gihyo.web.struts.action;

import gihyo.interfaces.AuthUserLocal;
import gihyo.web.struts.AuthUserForm;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * @struts.action
 *    path="/viewEditUser"
 *    scope="request"
 *    name="authUserForm"
 *    input="viewAllUsers.do"
 *    validate="false"
 *    roles="admin,manager"
 *
 * @struts.action-forward
 *    name="success"
 *    path="/WEB-INF/editUser.jsp"
 *    redirect="false"
 */
public class ViewEditUserAction extends AbstractAction {
    
    public ActionForward executeImpl(
      ActionMapping mapping,
      ActionForm form,
      HttpServletRequest request,
      HttpServletResponse response)
      throws Exception 
    {
        saveToken(request);
        AuthUserForm  userForm = (AuthUserForm) form;
        String account = userForm.getAccount();
        AuthUserLocal userLocal = getAuthUserLocal(account);
        userForm.copyFrom(userLocal);
        userForm.setRoleIdFk(userLocal.getAuthRole().getRoleId());
        request.setAttribute("AUTH_ROLES", getAllRoles());
        return mapping.findForward("success");
    }
}